<template>
  <div class="captured-image-container">
    <h1>Decorate your frame</h1>
    <div class="camera-result-container">
      <div class="camera-frame-container">
        <p>Image Preview</p>
        <div class="camera-frame" id="cameraMainFrame" v-bind:style="{'background': (selectedColor === 'polka' || selectedColor === 'winter') ? 'url(' + frameColor + ')' : frameColor}">
          <div id="my_result" class="camera-captured">
            <img :src="image" />
          </div>
        </div>
      </div>
      <div class="frame-theme-selector">
        <p>Select Frame Color:</p>
        <ul class="frame-color-list">
          <li @click="changeFrameTheme('burlywood')">
            <div class="select-color default"></div>
          </li>
          <li @click="changeFrameTheme('green')">
            <div class="select-color green"></div>
          </li>
          <li @click="changeFrameTheme('blue')">
            <div class="select-color blue"></div>
          </li>
          <li @click="changeFrameTheme('black')">
            <div class="select-color black"></div>
          </li>
          <li @click="changeFrameTheme('yellow')">
            <div class="select-color yellow"></div>
          </li>
          <li @click="changeFrameTheme('pink')">
            <div class="select-color pink"></div>
          </li>
          <li @click="changeFrameTheme('violet')">
            <div class="select-color violet"></div>
          </li>
          <li @click="changeFrameTheme('orange')">
            <div class="select-color orange"></div>
          </li>
          <li @click="changeFrameTheme('polka')">
            <div class="select-color polka"></div>
          </li>
          <li @click="changeFrameTheme('winter')">
            <div class="select-color winter"></div>
          </li>
        </ul>
      </div>
    </div>
    <br>
    <button class="button-cancel" @click="reset">Retake</button>
    <button class="button-confirm" @click="renderCanvas">Preview</button>
  </div>
</template>
<script>
import html2canvas from 'html2canvas';
import polkaPic from '@/assets/polka-dots.png'
import winterPic from '@/assets/winter.jpg'

export default {
  name: 'Preview',
  props: {
    image_file: String
  },
  data() {
    return {
      image: '',
      frameColor: 'burlywood',
      selectedColor: 'burlywood'
    }
  },
  mounted() {
    this.image = this.image_file;
  },
  methods: {
    reset() {
      this.$router.push({name: 'Home'});
    },
    changeFrameTheme(color) {
      this.selectedColor = color;
      switch(color) {
        case 'burlywood':
          this.frameColor = color;
          break;
        case 'green':
          this.frameColor = color;
          break;
        case 'blue':
          this.frameColor = color;
          break;
        case 'black':
          this.frameColor = color;
          break;
        case 'yellow':
          this.frameColor = color;
          break;
        case 'pink':
          this.frameColor = color;
          break;
        case 'violet':
          this.frameColor = color;
          break;
        case 'orange':
          this.frameColor = color;
          break;
        case 'polka':
          this.frameColor = polkaPic;
          break;
        case 'winter':
          this.frameColor = winterPic;
          break;
      }
    },
    renderCanvas() {
      let that = this;

      html2canvas(document.getElementById('cameraMainFrame')).then(function(canvas) {
        let toBase64 = canvas.toDataURL();
        that.$router.push({name: 'Finale', params:{image_file: toBase64}});
      });
    },
  }
};
</script>
<style scoped>
  .camera-result-container {
    display: flex;
    flex-direction: row;
    width: 75%;
    margin: 0 auto;
  }

  .camera-captured {
    margin: 0 auto;
    width:320px; 
    height:350px;
    padding-top: 15px;
  }

  .camera-frame {
    height: 320px;
    width: 350px;
    margin: 0 auto;
  }

  .camera-frame-container {
    float: left;
    width: 50%;
  }

  .frame-theme-selector {
    float: right;
    width: 50%;
  }

  .frame-color-list {
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
    list-style-type: none;
    width: 225px;
    margin: 0 auto;
    margin: 0 auto;
    padding: 0;
  }

  .select-color {
    height: 25px;
    width: 25px;
    margin-left: 10px;
    margin-right: 10px;
    margin-bottom: 10px;
    background: burlywood;
    cursor: pointer;
  }

  .select-color.default {background: burlywood;}
  .select-color.green {background: green;}
  .select-color.blue {background: blue;}
  .select-color.black {background: black;}
  .select-color.yellow {background: yellow;}
  .select-color.pink {background: pink;}
  .select-color.violet {background: violet;}
  .select-color.orange {background: orange;}
  .select-color.polka {
    background: url('../assets/polka-dots.png');
    background-size: cover;
  }
  .select-color.winter {
    background: url('../assets/winter.jpg');
    background-size: cover;
  }

  @media only screen and (min-width: 0) and (max-width: 991px) {
    .camera-result-container {
      flex-direction: column;
      width: 95%;
      margin: 0 auto;
    }

    .camera-frame-container,
    .frame-theme-selector {
      float: unset;
      width: 100%;
    }
  }
</style>